\ ef16.txt for P8, 27sep99cht, interpreter working
\       DUMP, SEE, VARIABLE, : all crash the system
\       improve error abort and DUMP
\
\ eForth.seq, adapted from Bill Muench's aFIG.b, 27feb96cht
\ V2.06, slow down I/O for stability of RS232, 11/nov95cht
\ V2.07, merge rectangle routine in hline27, 24nov95cht
\ V20.8, add RECTANGLE to ok28c.seq, add space to 'redef ',
\        use 82C51 for serial communication. 18mar96cht


CRR .( Common functions ) CRR

:: ?KEY  ?RX ;;
:: KEY   BEGIN ?RX UNTIL ;;      
:: EMIT  TX! ;;

:: ?DUP ( w -- w w | 0 ) DUP IF DUP THEN ;;
:: ROT ( w1 w2 w3 -- w2 w3 w1 ) >R SWAP R> SWAP ;;
:: 2DROP ( w w  -- ) DROP DROP ;;
:: 2DUP ( w1 w2 -- w1 w2 w1 w2 ) OVER OVER ;;
:: + ( w w -- w ) UM+ DROP ;;
:: NOT ( w -- w ) -1 LIT XOR ;;

CRR

::  NEGATE ( n -- -n ) NOT 1 LIT + ;;
:: DNEGATE ( d -- -d ) NOT >R NOT 1 LIT UM+ R> + ;;
:: - ( w w -- w ) NEGATE + ;;
:: ABS ( n -- +n ) DUP 0< IF NEGATE THEN ;;

CRR .( Comparison ) CRR

:: 0= ( w -- t ) IF 0 LIT EXIT THEN -1 LIT ;;
:: = ( w w -- t ) XOR IF 0 LIT EXIT THEN -1 LIT ;;
:: U< ( u u -- t ) 2DUP XOR 0< IF SWAP DROP 0< EXIT THEN - 0< ;;
::  < ( n n -- t ) 2DUP XOR 0< IF      DROP 0< EXIT THEN - 0< ;;
:: MAX ( n n -- n ) 2DUP      < IF SWAP THEN DROP ;;
:: MIN ( n n -- n ) 2DUP SWAP < IF SWAP THEN DROP ;;
:: WITHIN ( u ul uh -- t ) \ ul <= u < uh
  OVER - >R - R> U< ;;

CRR .( Divide ) CRR

:: UM/MOD ( ud u -- ur uq )
  2DUP U<
  IF NEGATE  $1F LIT
    FOR >R DUP UM+ >R >R DUP UM+ R> + DUP
        R> R@ SWAP >R UM+  R> OR
      IF >R DROP 1 LIT + R> ELSE DROP THEN R>
    NEXT DROP SWAP EXIT
  THEN DROP 2DROP  -1 LIT DUP ;;
:: M/MOD ( d n -- r q ) \ floored
  DUP 0<  DUP >R
  IF NEGATE >R DNEGATE R>
  THEN >R DUP 0< IF R@ + THEN R> UM/MOD R>
  IF SWAP NEGATE SWAP THEN ;;
:: /MOD ( n n -- r q ) OVER 0< SWAP M/MOD ;;
:: MOD ( n n -- r ) /MOD DROP ;;
:: / ( n n -- q ) /MOD SWAP DROP ;;

CRR .( Multiply ) CRR

:: UM* ( u u -- ud )
  0 LIT SWAP ( u1 0 u2 ) $1F LIT ( 19 decimal )
  FOR DUP UM+ >R >R DUP UM+ R> + R>
    IF >R OVER UM+ R> + THEN
  NEXT ROT DROP ;;
:: * ( n n -- n ) UM* DROP ;;
:: M* ( n n -- d )
  2DUP XOR 0< >R  ABS SWAP ABS UM*  R> IF DNEGATE THEN ;;
:: */MOD ( n n n -- r q ) >R M* R> M/MOD ;;
:: */ ( n n n -- q ) */MOD SWAP DROP ;;

CRR .( Bits & Bytes ) CRR

:: 1- ( a -- a ) -1 LIT + ;;
:: 1+ ( a -- a ) 1 LIT + ;;
:: CELL- ( a -- a ) -4 LIT + ;;
:: CELL+ ( a -- a ) 4 LIT + ;;
:: CELLS ( n -- 4n ) 4 LIT * ;;
:: CELL/ ( n -- n/4 ) 4 LIT / ;;
:: BL ( -- 32 ) 20 LIT ;;
:: >CHAR ( c -- c )
  $7F LIT AND DUP $7F LIT BL WITHIN
  IF DROP ( CHAR _ ) $5F LIT THEN ;;
:: ALIGNED ( b -- a ) 3 LIT + FFFFFFFC LIT AND ;;

CRR .( Memory access ) CRR

:: +! ( n a -- ) SWAP OVER @ + SWAP ! ;;
:: 2! ( d a -- ) SWAP OVER ! CELL+ ! ;;
:: 2@ ( a -- d ) DUP CELL+ @ SWAP @ ;;
:: COUNT ( b -- b +n ) DUP 1+ SWAP C@ ;;
:: HERE ( -- a ) CP @ ;;
:: PAD ( -- a ) HERE 50 LIT + ;;
:: TIB ( -- a ) #TIB CELL+ @ ;;
CRR
:: @EXECUTE ( a -- ) @ ?DUP IF EXECUTE THEN ;;
:: CMOVE ( b b u -- )
  FOR AFT >R COUNT R@ C! R> 1+ THEN NEXT 2DROP ;;
:: FILL ( b u c -- )
  SWAP FOR SWAP AFT 2DUP C! 1+ THEN NEXT 2DROP ;;
:: ERASE ( b u -- ) 0 LIT FILL ;;
:: PACK$ ( b u a -- a ) 
  DUP >R 
  2DUP + $FFFFFFFC LIT AND 0 LIT SWAP ! \ LAST WORD FILL 0 1ST
  2DUP C! 1+ SWAP CMOVE  R> ;;

CRR .( Numeric Output ) CRR \ single precision

:: DIGIT ( u -- c ) 9 LIT OVER < 7 LIT AND +
  ( CHAR 0 ) 30 LIT + ;;
:: EXTRACT ( n base -- n c ) 0 LIT SWAP UM/MOD SWAP DIGIT ;;
:: <# ( -- ) PAD HLD ! ;;
:: HOLD ( c -- ) HLD @ 1- DUP HLD ! C! ;;
:: # ( u -- u ) BASE @ EXTRACT HOLD ;;
:: #S ( u -- 0 ) BEGIN # DUP WHILE REPEAT ;;
CRR
:: SIGN ( n -- ) 0< IF ( CHAR - ) 2D LIT HOLD THEN ;;
:: #> ( w -- b u ) DROP HLD @ PAD OVER - ;;
:: str ( n -- b u ) DUP >R ABS <# #S R> SIGN #> ;;
:: HEX ( -- ) 10 LIT BASE ! ;;
:: DECIMAL ( -- ) 0A LIT BASE ! ;;

CRR .( Numeric Input ) CRR \ single precision

:: DIGIT? ( c base -- u t )
  >R ( CHAR 0 ) 30 LIT - 9 LIT OVER <
  IF 7 LIT - DUP 0A LIT  < OR THEN DUP R> U< ;;
:: NUMBER? ( a -- n T | a F )
  BASE @ >R  0 LIT OVER COUNT ( a 0 b n)
  OVER C@ ( CHAR $ ) 24 LIT =
  IF HEX SWAP 1+ SWAP 1- THEN ( a 0 b' n')
  OVER C@ ( CHAR - ) 2D LIT = >R ( a 0 b n)
  SWAP R@ - SWAP R@ + ( a 0 b" n") ?DUP
  IF 1- ( a 0 b n)
    FOR DUP >R C@ BASE @ DIGIT?
      WHILE SWAP BASE @ * +  R> 1+
    NEXT DROP R@ ( b ?sign) IF NEGATE THEN SWAP
      ELSE R> R> ( b index) 2DROP ( digit number) 2DROP 0 LIT
      THEN DUP
  THEN R> ( n ?sign) 2DROP R> BASE ! ;;

CRR .( Basic I/O ) CRR

:: ?KEY ( -- c T | F ) KEY -1 LIT ;;
:: SPACE ( -- ) BL EMIT ;;
CRR
:: CHARS ( +n c -- ) \ ???ANS conflict
  SWAP 0 LIT MAX FOR AFT DUP EMIT THEN NEXT DROP ;;
:: SPACES ( +n -- ) BL CHARS ;;
:: TYPE ( b u -- ) FOR AFT COUNT EMIT THEN NEXT DROP ;;
:: CR ( -- ) ( =Cr ) 0D LIT EMIT ( =Lf ) 0A LIT EMIT ;;
:: do$ ( -- a )
  R> R@ R> COUNT + ALIGNED >R SWAP >R ;; COMPILE-ONLY
CRR
:: $"| ( -- a ) do$ ;; COMPILE-ONLY
:: ."| ( -- ) do$ COUNT TYPE ;; COMPILE-ONLY
::  .R ( n +n -- ) >R str      R> OVER - SPACES TYPE ;;
:: U.R ( u +n -- ) >R <# #S #> R> OVER - SPACES TYPE ;;
:: U. ( u -- ) <# #S #> SPACE TYPE ;;
::  . ( n -- ) BASE @ 0A LIT XOR IF U. EXIT THEN str SPACE TYPE ;;
:: ? ( a -- ) @ . ;;

CRR .( Parsing ) CRR

:: (parse) ( b u c -- b u delta ; <string> )
  tmp !  OVER >R  DUP \ b u u
  IF 1-  tmp C@ BL =
    IF \ b u' \ 'skip'
      FOR BL OVER C@ - 0< NOT  WHILE 1+
      NEXT ( b) R> DROP 0 LIT DUP EXIT \ all delim
        THEN  R>
    THEN OVER SWAP \ b' b' u' \ 'scan'
    FOR tmp C@ OVER C@ -  tmp C@ BL =
      IF 0< THEN WHILE 1+
    NEXT DUP >R  
      ELSE R> DROP DUP 1+ >R
      THEN OVER -  R>  R> - EXIT
  THEN ( b u) OVER R> - ;;
:: PARSE ( c -- b u ; <string> )
  >R  TIB >IN @ +  #TIB @ >IN @ -  R> (parse) >IN +! ;;
:: CHAR ( -- c ) BL PARSE DROP C@ ;;
:: TOKEN ( -- a ;; <string> )
  BL PARSE 1F LIT MIN HERE CELL+ PACK$ ;;
:: WORD ( c -- a ; <string> ) PARSE HERE CELL+ PACK$ ;;

CRR .( Dictionary Search ) CRR

:: NAME> ( a -- xt ) COUNT 1F LIT AND + ALIGNED ;;
:: SAME? ( a a u -- a a f \ -0+ )
  $1F LIT AND CELL/ 
  FOR AFT OVER R@ CELLS + @
          OVER R@ CELLS + @ -  ?DUP
    IF R> DROP EXIT THEN THEN
  NEXT 0 LIT ;;
:: find ( a va -- xt na | a F ) \ ************ be careful here!!!
  SWAP              \ va a
  DUP C@ tmp !  \ va a  \ get cell count                      !!!
  DUP @ >R          \ va a  \ count
  CELL+ SWAP        \ a' va
  BEGIN @ DUP       \ a' na na
    IF DUP @ FFFFFF3F LIT AND  R@ XOR \ ignore lexicon bits
      IF CELL+ -1 LIT ELSE CELL+ tmp @ SAME? THEN
    ELSE R> DROP SWAP CELL- SWAP EXIT \ a F
    THEN
  WHILE CELL- CELL- \ a' la
  REPEAT R> DROP SWAP DROP CELL-  DUP NAME> SWAP ;;
:: NAME? ( a -- xt na | a F )
  CONTEXT  find  ;;

CRR .( Terminal ) CRR

:: ^H ( b b b -- b b b ) \ backspace
  >R OVER R> SWAP OVER XOR
  IF ( =BkSp ) 8 LIT EMIT
     1-         BL EMIT
     ( =BkSp ) 8 LIT EMIT
  THEN ;;
:: TAP ( bot eot cur c -- bot eot cur )
  DUP EMIT OVER C! 1+ ;;
:: kTAP ( bot eot cur c -- bot eot cur )
  DUP ( =Cr ) 0D LIT XOR
  OVER ( =Lf ) 0A LIT XOR AND
  IF ( =BkSp ) 8 LIT XOR IF BL TAP ELSE ^H THEN EXIT
  THEN DROP SWAP DROP DUP ;;
CRR
:: accept ( b u -- b u )
  OVER + OVER
  BEGIN 2DUP XOR
  WHILE  KEY  DUP BL -  5F LIT U<
    IF TAP ELSE kTAP THEN
  REPEAT DROP  OVER - ;;
:: EXPECT ( b u -- ) accept SPAN ! DROP ;;
:: QUERY ( -- )
  TIB 50 LIT accept #TIB !  DROP 0 LIT >IN ! ;;

CRR .( Error handling ) CRR

:: ABORT ( -- ) 'ABORT @EXECUTE ;;
:: abort" ( f -- ) IF do$ COUNT TYPE ABORT THEN do$ DROP ;; COMPILE-ONLY

CRR .( Interpret ) CRR

:: ERROR ( a -- ) 
         space count type $3F LIT EMIT
         $1B LIT ( ESC) EMIT
         CR ABORT
:: $INTERPRET ( a -- )
  NAME?  ?DUP
  IF C@ 40 LIT AND
    abort" $LIT compile only" EXECUTE EXIT
  THEN NUMBER? IF EXIT ELSE ERROR THEN 
  ;;

:: [ ( -- ) DOLIT $INTERPRET 'EVAL ! ;; IMMEDIATE
:: .OK ( -- ) DOLIT $INTERPRET 'EVAL @ = 
  IF CR >R >R >R DUP . R> DUP . R> DUP . R> DUP . ."| $LIT  fg>" 
  THEN ;;
:: EVAL ( -- )
  BEGIN TOKEN DUP C@
  WHILE 'EVAL @EXECUTE \ ?STACK
  REPEAT DROP .OK ;;

CRR .( Shell ) CRR

:: QUIT ( -- )
   ( =TIB) 100 LIT 'TIB ! 
   [ BEGIN QUERY EVAL AGAIN ;;

CRR .( Compiler Primitives ) CRR

:: ' ( -- xt ) TOKEN NAME? IF EXIT THEN ERROR
:: ALLOT ( n -- ) ALIGNED CP +! ;;
:: , ( w -- ) HERE DUP CELL+ CP ! ! ;; 
:: [COMPILE] ( -- ; <string> ) ' , ;; IMMEDIATE
CRR
:: COMPILE ( -- ) R> DUP @ , CELL+ >R ;; 
:: LITERAL doLIT doLIT , , ;; IMMEDIATE
:: $," ( -- ) ( CHAR " ) 22 LIT WORD COUNT + ALIGNED CP ! ;;
:: RECURSE ( -- ) LAST @ NAME> , ;; IMMEDIATE

CRR .( Name Compiler ) CRR

:: ?UNIQUE ( a -- a )
  DUP NAME? 
  ?DUP IF COUNT 1F LIT AND SPACE TYPE ."| $LIT  reDef "
  THEN DROP ;;
:: $,n ( a -- )
  DUP @
  IF ?UNIQUE
    ( na ) DUP NAME> CP ! 
    ( na) DUP LAST ! \ for OVERT
    ( na) CELL-
    ( la) CONTEXT @ SWAP ! EXIT
  THEN ERROR

CRR .( FORTH Compiler ) CRR

:: $COMPILE ( a -- )
  NAME? ?DUP
  IF @ 80 LIT AND
    IF EXECUTE ELSE , THEN EXIT
  THEN NUMBER?
  IF LITERAL EXIT
  THEN ERROR
:: OVERT ( -- ) LAST @ CONTEXT ! ;;
:: ; ( -- )
  DOLIT EXIT , [ OVERT ;; COMPILE-ONLY IMMEDIATE
:: ] ( -- ) DOLIT $COMPILE 'EVAL ! ;;
:: : ( -- ; <string> ) TOKEN $,n ( ' doLIST ) 6 LIT , ] ;;

CRR .( Defining Words ) CRR

:: CODE ( -- ; <string> ) TOKEN $,n OVERT ;;
:: CREATE ( -- ; <string> ) CODE 203D LIT , ;;
:: VARIABLE ( -- ; <string> ) CREATE 0 LIT , ;;
:: CONSTANT ( n -- ; <string> ) CODE 2004 LIT , , ;;

CRR .( Tools ) CRR

:: _TYPE ( b u -- )
  FOR AFT COUNT >CHAR EMIT THEN NEXT DROP ;;
:: dm+ ( b u -- b )
  OVER 6 LIT U.R SPACE FOR AFT COUNT 3 LIT U.R THEN NEXT ;;
:: DUMP ( b u -- )
  0F LIT + 10 LIT /
  FOR AFT CR 10 LIT 2DUP dm+ ROT ROT
     SPACE _TYPE
  THEN NEXT  DROP  ;;

CRR

:: >NAME ( xt -- na | F )
  CONTEXT
  BEGIN @ DUP
  WHILE 2DUP NAME> XOR
    IF CELL-
    ELSE SWAP DROP EXIT
    THEN
  REPEAT SWAP DROP ;;
:: .ID ( a -- )
  ?DUP IF COUNT $01F LIT AND _TYPE SPACE 
  ELSE SPACE ."| $LIT {noName}" THEN ;;
:: SEE ( -- ; <string> )
  ' CR
  BEGIN
    20 LIT FOR
      CELL+ DUP @ DUP IF >NAME THEN ?DUP
      IF SPACE .ID ELSE DUP @ U. THEN
    NEXT KEY 0D LIT =                  \ can't use ESC on terminal
  UNTIL DROP ;;
:: WORDS ( -- )
  CR  CONTEXT 
  BEGIN @ ?DUP
  WHILE DUP SPACE .ID CELL-
  REPEAT ;;
:: FORGET ( -- )
  TOKEN NAME? ?DUP
  IF CELL- DUP CP ! 
     @ DUP CONTEXT ! LAST !
     DROP EXIT
  THEN ERROR

\ ::   DIAGNOSE     ( - )
\      $65 LIT
\     EMIT
\ 'F'  prove UM+ 0<         \ carry, TRUE, FALSE
\      0 LIT 0< -2 LIT 0<     \ 0 FFFF
\      UM+ DROP               \ FFFF ( -1)
\      3 LIT UM+ UM+ DROP     \ 3
\      $43 LIT UM+ DROP       \ 'F'
\     EMIT
\ 'o' logic: XOR AND OR
\      $4F LIT $6F LIT XOR    \ 20h
\      $F0 LIT AND
\      $4F LIT OR
\     EMIT
\ 'r' stack: DUP OVER SWAP DROP
\       8 LIT 6 LIT SWAP
\       OVER XOR 3 LIT AND AND
\       $70 LIT UM+ DROP      \ 'r'
\     EMIT
\ 't'-- prove BRANCH ?BRANCH
\       0 LIT IF $3F LIT THEN
\       -1 LIT IF $74 LIT ELSE $21 LIT THEN
\     EMIT
\ 'h' -- @ ! test memeory address
\       $68 LIT $80 LIT !
\       $80 LIT @
\     EMIT
\ 'M' -- prove >R R> R@
\       $4D LIT >R R@ R> AND
\     EMIT
\ 'l'  -- prove 'next' can run
\       61 LIT $A LIT FOR 1 LIT UM+ DROP NEXT
\     EMIT
\ 'emi' -- prove mul, dupy, popy
\       $656D LIT $1000000 LIT UM*
\       SWAP $100 LIT UM*
\       SWAP DROP
\     EMIT EMIT
\ ' C' -- prove div
\       $2043 LIT 0 LIT $100 LIT UM/MOD
\     EMIT EMIT
\       ;;

CRR .( Hardware reset ) CRR

:: COLD ( -- )
\    DIAGNOSE
    CR ."| $LIT eForth in C, Ver 1.0, 2009"
    QUIT
    ;;

CRR .( Structures ) CRR

:: <MARK ( -- a ) HERE ;;
:: <RESOLVE ( a -- ) , ;;
:: >MARK ( -- A ) HERE 0 LIT , ;;
:: >RESOLVE ( A -- ) <MARK SWAP ! ;;
CRR
:: FOR ( -- a ) COMPILE >R <MARK ;; IMMEDIATE
:: BEGIN ( -- a ) <MARK ;; IMMEDIATE
:: NEXT ( a -- ) COMPILE doNEXT <RESOLVE ;; IMMEDIATE
:: UNTIL ( a -- ) COMPILE QBRANCH <RESOLVE ;; IMMEDIATE
CRR
:: AGAIN ( a -- ) COMPILE  BRANCH <RESOLVE ;; IMMEDIATE
:: IF ( -- A )   COMPILE QBRANCH >MARK ;; IMMEDIATE
:: AHEAD ( -- A ) COMPILE BRANCH >MARK ;; IMMEDIATE
:: REPEAT ( A a -- ) AGAIN >RESOLVE ;; IMMEDIATE
CRR
:: THEN ( A -- ) >RESOLVE ;; IMMEDIATE
:: AFT ( a -- a A ) DROP AHEAD BEGIN SWAP ;; IMMEDIATE
:: ELSE ( A -- A )  AHEAD SWAP THEN ;; IMMEDIATE
:: WHEN ( a A -- a A a ) IF OVER ;; IMMEDIATE
:: WHILE ( a -- A a )    IF SWAP ;; IMMEDIATE

CRR .( compilers ) CRR

:: ABORT" ( -- ; <string> ) COMPILE abort" $," ;; IMMEDIATE
:: $" ( -- ; <string> ) DOLIT $"| HERE ! $," ;; IMMEDIATE
:: ." ( -- ; <string> ) DOLIT ."| HERE ! $," ;; IMMEDIATE
CRR
(makeHead) .( ( -- ) 29 LIT PARSE TYPE ;; IMMEDIATE
(makeHead) \ ( -- ) $A LIT WORD DROP ;; IMMEDIATE 
(makeHead) ( 29 LIT PARSE 2DROP ;;        IMMEDIATE
(makeHead) IMMEDIATE 80 LIT LAST @ @ OR LAST @ ! ;;

CRR



